=== debian/changelog ===
ros-noetic-psen-scan-v2 (0.10.2-1focal) focal; urgency=high

  * Remove zoneset bits from IOState.input field since its redundant to the active_zoneset field (#311)
  * Inform about missing configuration confirmation
  * Ignore changes of unused IOs. Fix #321
  * Fill "io_states" vector as received instead of order by theta to avoid flickering. Fix #320
  * Fixed bug of multiple zonesets being visible #328
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Wed, 02 Nov 2022 23:00:00 -0000

ros-noetic-psen-scan-v2 (0.10.1-1focal) focal; urgency=high

  * Separate 'PinState' formating from 'formatRange' (#313)
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 23 Jan 2022 23:00:00 -0000

ros-noetic-psen-scan-v2 (0.10.0-1focal) focal; urgency=high

  * Change to new versioning method for ROS1 (0.10.0+) and ROS2 (0.20.0+).
  * Deprecate get/set methods with 'get/set' prefix in favour of methods without the prefix(#298)
  * ADD IO states to LaserScan and publish them at ~/io_state (#281)
  * Renaming Slave to Subscriber (#303)
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Wed, 19 Jan 2022 23:00:00 -0000

ros-noetic-psen-scan-v2 (0.3.4-1focal) focal; urgency=high

  * Prevent error when diagnostics are disabled. Fix #294
  * Set exception in stop-future
  * Apply clang-tidy fixes to header-files. Fix #277
  * Remove latched flag from active zoneset topic
  * API change: convenience usage of ScannerConfiguration
  * Remove unrelated parameter DEFAULT_X_AXIS_ROTATION from standalone
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 19 Dec 2021 23:00:00 -0000

ros-noetic-psen-scan-v2 (0.3.3-1focal) focal; urgency=high

  * Introduce error state and set exception in start-future
  * Remove dependency on pilz_testutils
  * Always build hardware tests
  * Internal refactorings
  * Importing the config xml-file and publishing the zoneconfiguration
  * Add active zoneset to LaserScan
  * Publish active zoneset id to ~/active_zoneset
  * Add active zoneset visualization in rviz
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Tue, 09 Nov 2021 23:00:00 -0000

ros-noetic-psen-scan-v2 (0.3.2-1focal) focal; urgency=high

  * Improve performance of standalone part
    
    Introduce RawDataPtr
    
    Write to std::stringstream instead of constructing from std::string
    
    Pass by reference wherever possible
  * Make release build the default
  * Calculate timestamp as the time of the first ray (udp communication time is neglected)
  * API: Add timestamp (nanoseconds since epoch) to LaserScan
  * API: Add scan counter to LaserScan
  * API: remove LaserScan equality operator
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Wed, 15 Sep 2021 22:00:00 -0000

ros-noetic-psen-scan-v2 (0.3.1-1focal) focal; urgency=high

  * Rename urdf links
  * Apply tf prefix equals node name
  * API change: rename launch-file argument prefix->tf_prefix
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Tue, 20 Jul 2021 22:00:00 -0000

ros-noetic-psen-scan-v2 (0.3.0-1focal) focal; urgency=high

  * Set prefix for node name (same value as for tf frames)
  * Introduce bringup.launch for starting only the scanner node
  * Omit closing the data client before destruction. Fixes #212
  * Distance value at angle_end is now included in the scan range
  * Default scan range changed to [-137.4..137.4]deg at 0.1 deg resolution
  * Add options for modifying resolution and enabling intensities
  * Add launchfile option for disabling rviz at startup (default: enable)
  * Handle the infinity codes from the scanner correctly
  * Inform user about current scan range
  * Fix wrong behavior when angle_start and angle_end are equal
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Mon, 28 Jun 2021 22:00:00 -0000

ros-noetic-psen-scan-v2 (0.2.1-1focal) focal; urgency=high

  * Fix issues with smaller angle ranges than default range (#183 <https://github.com/PilzDE/psen_scan_v2/issues/183>)
  * Add action for pull request todos (#184 <https://github.com/PilzDE/psen_scan_v2/issues/184>)
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 18 Apr 2021 22:00:00 -0000

ros-noetic-psen-scan-v2 (0.2.0-1focal) focal; urgency=high

  * Combine multiple monitoring frames into one scan (#173 <https://github.com/PilzDE/psen_scan_v2/issues/173>)
  * Contributors: Pilz GmbH and Co. KG
  * API change: Driver waits for scan round to complete before sending measurement data by default
  * Introducing new parameter fragmented_scans to switch back to faster fragmented laser_scan messages
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 04 Apr 2021 22:00:00 -0000

ros-noetic-psen-scan-v2 (0.1.6-1focal) focal; urgency=high

  * Separate ROS and standalone CMakeLists: Closes #169
  * Minor restructuring. Closes #175
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 21 Mar 2021 23:00:00 -0000

ros-noetic-psen-scan-v2 (0.1.5-1focal) focal; urgency=high

  * Make specifying host ip optional
  * Reorder Readme sections
  * API change: A scan is published only if it contains measurement data
  * Make tests build in standalone with or without ROS installed
  * Document key components in a meaningful expressive way
  * Enable building the standalone lib using MSVC
  * Enable separate building of cpp-lib; extract sources into subproject psen_scan_v2_standalone
  * Renames ScanRange and DefaultScanRange to improve usability
  * Improve namespace hierarchy and move files to respective subfolders
  * Use defaults ports in ScannerConfiguration
  * Contributors: Pilz GmbH and Co. KG


