=== debian/control ===
Source: ros-noetic-psen-scan-v2
Section: misc
Priority: optional
Maintainer: Alexander Gutenkunst <a.gutenkunst@pilz.de>
Build-Depends: debhelper (>= 9.0.0), libfmt-dev, libtinyxml2-dev, ros-noetic-catkin, ros-noetic-cmake-modules, ros-noetic-code-coverage <!nocheck>, ros-noetic-geometry-msgs, ros-noetic-message-generation, ros-noetic-rosbag <!nocheck>, ros-noetic-rosconsole-bridge, ros-noetic-roscpp, ros-noetic-roslaunch <!nocheck>, ros-noetic-rostest <!nocheck>, ros-noetic-rosunit <!nocheck>, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-visualization-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-psen-scan-v2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfmt-dev, libtinyxml2-dev, ros-noetic-geometry-msgs, ros-noetic-message-runtime, ros-noetic-robot-state-publisher, ros-noetic-rosconsole-bridge, ros-noetic-roscpp, ros-noetic-roslaunch, ros-noetic-rviz, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-visualization-msgs, ros-noetic-xacro
Description: ROS support for the Pilz laser scanner
